// You can import API functions like this from D3.js.
import { select,csv,scaleLinear,scaleBand,max,axisLeft,
  axisBottom ,format} from 'd3';

// You can import local modules like this. See message.js!
import { message } from './myMessage';

// This line uses D3 to set the text of   the message div.
//select('#message').text(message);

var svg=select('svg');

var width=+svg.attr('width');
var height=+svg.attr('height');


var render=data=>{

  var margin={top:80,bottom:100,left:80,right:80};
  
  var xValue=d=>d.population;
  var yValue=d=>d.country;
  var innerWidth=width-margin.left-margin.right;
  var innerHeight=height-margin.top-margin.bottom;
  var xScale=scaleLinear().domain([0,max(data,xValue)])
  		.range([0,innerWidth]);
  
  var yScale=scaleBand().domain(data.map(yValue)).range([0,innerHeight]).padding(0.1);
  
  var g=svg.append('g').attr('transform',`translate(${margin.top},${margin.left})`);
 	var yaxis=axisLeft(yScale);
  var xaxisFormart=number=>{	
    format('.3s')(number);
  }
  		
  
  var xaxis=axisBottom(xScale)
  	.tickSize(-innerHeight);
  
  var yg=g.append('g').call(yaxis);
  yg.selectAll('.domain, .tick line').remove();
  
  var xg=g.append('g').call(xaxis).attr('transform',`translate(0,${innerHeight})`);
  xg.selectAll('.domain').remove();
  xg.append("text").attr('x', innerWidth / 2).attr('fill','black').text('population');
 
  g.selectAll('rect').data(data).enter().append('rect')
  	.attr('y',d=>yScale(yValue(d)))
  	.attr('width',d=>xScale(xValue(d)))
		.attr('height',yScale.bandwidth());
  
  g.append('text').attr('x',350).text('top 10 all country population');

}

csv('data.csv').then(data=>{

  data.forEach(d=>{
  
    d.population=+d.population*100;
  });
  
  render(data);

});


